<div class="row">
  <div class="col-12 text-center">
    <h3>4. Scratchboard</h3>
  </div>
</div>
<div class="row">
  <div class="form-group col-md-4">
    <label for="searchValue" class="col-form-label col-form-label-sm">4.1. Search Value</label>
    <input type="text" class="form-control form-control-sm" id="searchValue" aria-describedby="searchValueHelp"
      placeholder="1" [(ngModel)]="searchValue" (ngModelChange)="updateResult()">
    <small id="searchValueHelp" class="form-text text-muted text-center">Value to find</small>
  </div>
  <div class="form-group col-md-4">
    <label for="path" class="col-form-label col-form-label-sm">4.2. Path</label>
    <input type="text" class="form-control form-control-sm" id="path" aria-describedby="pathHelp"
      placeholder="books[].id" [(ngModel)]="path" (ngModelChange)="updateResult()">
    <small id="pathHelp" class="form-text text-muted text-center">Path to transverse</small>
  </div>
  <div class="form-group col-md-4">
    <label for="outputKey" class="col-form-label col-form-label-sm">4.3. Output Key</label>
    <input type="text" class="form-control form-control-sm" id="outputKey" aria-describedby="outputKeyHelp"
      placeholder="name" [(ngModel)]="outputKey" (ngModelChange)="updateResult()">
    <small id="outputKeyHelp" class="form-text text-muted text-center">Extract from result</small>
  </div>
</div>
<div class="row">
  <div class="col-12 form-group text-center">
    <label for="pipeSyntax" class="col-form-label col-form-label-sm">Pipe Syntax</label>
    <code class="d-block" id="pipeSyntax">
        <ng-container ngNonBindable>
          {{ 
        </ng-container>
        '{{searchValue}}' | dictionary : inputDictionary : '{{path}}' {{ outputKey ? ': ' + "'" + outputKey + "'" : '' }}
        <ng-container ngNonBindable>
          }}
        </ng-container>
      </code>
  </div>
</div>
<div class="row" style="height: calc(100vh - 480px);">
  <div class="form-group col-xl-8 border border-transparent" [ngClass]="{ 'border border-danger': error }">
    <label for="inputDictionary" class="col-form-label col-form-label-sm">4.4. Input Dictionary:</label>
    <ngx-monaco-editor class="border border-muted" style="height: calc(100vh - 480px)" [options]="editorOptions" [(ngModel)]="rawJson">
    </ngx-monaco-editor>
    <small id="inputDictionaryError" class="form-text text-danger text-center" *ngIf="error">{{error}}</small>
  </div>
  <div class="form-group col-xl-4" style="height: calc(100vh - 480px)">
    <label for="result" class="col-form-label col-form-label-sm">4.5. Result{{ result ? 'ing ' + (resultType) : ''}}:</label>
    <ngx-json-viewer [json]="result" [expanded]="true"></ngx-json-viewer>
  </div>
</div>